/*
 *  "Yylex_FIRST.java"
 *     	Esta clase ha sido creada con JLex y corresponde al analizador lxico principal del programa. Recoge los tokens de entrada
 *	 y se los pasa a parser_FIRST. 
 *
 *  Copyright (C) 2005, 2006 Jose Manuel Martnez Garca <glasnosh@gmail.com>
 *
 *  This program is "Open Source" software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License (explicitly version 2 
 *   of the License).
 */



import java.lang.*;
import java.io.*;
import java.util.*;
import java_cup.runtime.Symbol;


class Yylex_FIRST implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 256;
	private final int YY_EOF = 257;
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private boolean yy_at_bol;
	private int yy_lexical_state;

	Yylex_FIRST (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	Yylex_FIRST (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}
	
	Yylex_FIRST (String cadena){
		this();
		if (null == cadena) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new StringReader(cadena));
	}

	private Yylex_FIRST () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int yy_state_dtrans[] = {
		0
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NOT_ACCEPT,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NOT_ACCEPT,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NOT_ACCEPT,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NOT_ACCEPT,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NOT_ACCEPT,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NOT_ACCEPT,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NOT_ACCEPT,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NOT_ACCEPT,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NOT_ACCEPT,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NOT_ACCEPT,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NOT_ACCEPT,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NOT_ACCEPT,
		/* 64 */ YY_NOT_ACCEPT,
		/* 65 */ YY_NOT_ACCEPT,
		/* 66 */ YY_NOT_ACCEPT,
		/* 67 */ YY_NOT_ACCEPT,
		/* 68 */ YY_NOT_ACCEPT,
		/* 69 */ YY_NOT_ACCEPT,
		/* 70 */ YY_NOT_ACCEPT,
		/* 71 */ YY_NOT_ACCEPT,
		/* 72 */ YY_NOT_ACCEPT,
		/* 73 */ YY_NOT_ACCEPT,
		/* 74 */ YY_NOT_ACCEPT,
		/* 75 */ YY_NOT_ACCEPT,
		/* 76 */ YY_NOT_ACCEPT,
		/* 77 */ YY_NOT_ACCEPT,
		/* 78 */ YY_NOT_ACCEPT,
		/* 79 */ YY_NOT_ACCEPT,
		/* 80 */ YY_NOT_ACCEPT,
		/* 81 */ YY_NOT_ACCEPT,
		/* 82 */ YY_NOT_ACCEPT,
		/* 83 */ YY_NOT_ACCEPT,
		/* 84 */ YY_NOT_ACCEPT,
		/* 85 */ YY_NOT_ACCEPT,
		/* 86 */ YY_NOT_ACCEPT,
		/* 87 */ YY_NOT_ACCEPT,
		/* 88 */ YY_NOT_ACCEPT,
		/* 89 */ YY_NOT_ACCEPT,
		/* 90 */ YY_NOT_ACCEPT,
		/* 91 */ YY_NOT_ACCEPT,
		/* 92 */ YY_NOT_ACCEPT,
		/* 93 */ YY_NOT_ACCEPT,
		/* 94 */ YY_NOT_ACCEPT,
		/* 95 */ YY_NOT_ACCEPT,
		/* 96 */ YY_NOT_ACCEPT,
		/* 97 */ YY_NOT_ACCEPT,
		/* 98 */ YY_NOT_ACCEPT,
		/* 99 */ YY_NOT_ACCEPT,
		/* 100 */ YY_NOT_ACCEPT,
		/* 101 */ YY_NOT_ACCEPT,
		/* 102 */ YY_NOT_ACCEPT,
		/* 103 */ YY_NOT_ACCEPT,
		/* 104 */ YY_NOT_ACCEPT,
		/* 105 */ YY_NOT_ACCEPT,
		/* 106 */ YY_NOT_ACCEPT,
		/* 107 */ YY_NOT_ACCEPT,
		/* 108 */ YY_NOT_ACCEPT,
		/* 109 */ YY_NOT_ACCEPT,
		/* 110 */ YY_NOT_ACCEPT,
		/* 111 */ YY_NOT_ACCEPT,
		/* 112 */ YY_NOT_ACCEPT,
		/* 113 */ YY_NOT_ACCEPT,
		/* 114 */ YY_NOT_ACCEPT,
		/* 115 */ YY_NOT_ACCEPT,
		/* 116 */ YY_NOT_ACCEPT,
		/* 117 */ YY_NOT_ACCEPT,
		/* 118 */ YY_NOT_ACCEPT,
		/* 119 */ YY_NOT_ACCEPT,
		/* 120 */ YY_NOT_ACCEPT,
		/* 121 */ YY_NOT_ACCEPT,
		/* 122 */ YY_NOT_ACCEPT,
		/* 123 */ YY_NOT_ACCEPT,
		/* 124 */ YY_NOT_ACCEPT,
		/* 125 */ YY_NOT_ACCEPT,
		/* 126 */ YY_NOT_ACCEPT,
		/* 127 */ YY_NOT_ACCEPT,
		/* 128 */ YY_NOT_ACCEPT,
		/* 129 */ YY_NOT_ACCEPT,
		/* 130 */ YY_NO_ANCHOR,
		/* 131 */ YY_NOT_ACCEPT,
		/* 132 */ YY_NOT_ACCEPT,
		/* 133 */ YY_NOT_ACCEPT,
		/* 134 */ YY_NOT_ACCEPT,
		/* 135 */ YY_NOT_ACCEPT,
		/* 136 */ YY_NOT_ACCEPT,
		/* 137 */ YY_NOT_ACCEPT,
		/* 138 */ YY_NOT_ACCEPT,
		/* 139 */ YY_NOT_ACCEPT,
		/* 140 */ YY_NOT_ACCEPT,
		/* 141 */ YY_NOT_ACCEPT,
		/* 142 */ YY_NOT_ACCEPT,
		/* 143 */ YY_NOT_ACCEPT,
		/* 144 */ YY_NOT_ACCEPT,
		/* 145 */ YY_NOT_ACCEPT,
		/* 146 */ YY_NOT_ACCEPT,
		/* 147 */ YY_NOT_ACCEPT,
		/* 148 */ YY_NOT_ACCEPT,
		/* 149 */ YY_NOT_ACCEPT,
		/* 150 */ YY_NOT_ACCEPT,
		/* 151 */ YY_NOT_ACCEPT,
		/* 152 */ YY_NOT_ACCEPT,
		/* 153 */ YY_NOT_ACCEPT,
		/* 154 */ YY_NOT_ACCEPT,
		/* 155 */ YY_NOT_ACCEPT,
		/* 156 */ YY_NOT_ACCEPT,
		/* 157 */ YY_NOT_ACCEPT,
		/* 158 */ YY_NOT_ACCEPT,
		/* 159 */ YY_NOT_ACCEPT,
		/* 160 */ YY_NOT_ACCEPT,
		/* 161 */ YY_NOT_ACCEPT
	};
	private int yy_cmap[] = unpackFromString(1,258,
"36:9,35:2,36:2,0,36:18,35,29,36:6,22,23,36:2,34,30,36:14,32,33,31,36:2,2,21" +
",20,12,8,5,9,15,19,16,36,6,18,11,4,13,14,10,7,1,3,36:4,17,36:3,27,36:2,24:8" +
",36:11,25,36,26,36,25:3,36:49,28,36:83,37:2")[0];

	private int yy_rmap[] = unpackFromString(1,162,
"0,1,2,3:10,4,3,5,3:25,6,7,8,3,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,2" +
"4,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,4" +
"9,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,7" +
"4,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,9" +
"9,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,1" +
"18,119,120,121,122,123,124,125")[0];

	private int yy_nxt[][] = unpackFromString(126,38,
"-1,1,42,44:2,130,44:2,2,46,48,44,50,52,44:4,54,56,58,44,3,4,5,6,7,8,9,10,60" +
",44,62,11,12,13,44,14,-1:2,41,-1:42,49,-1:3,51,-1:99,13,-1:23,73,-1:19,134," +
"-1:40,43,-1:3,132,-1:6,131,45,-1:2,133,-1:26,63,-1:29,66,-1:45,152,-1:33,15" +
"3,-1:35,53,-1:38,137,-1:40,159,-1:30,138,-1:44,55,-1:10,151,-1:34,68,-1:23," +
"57,-1:16,136,-1:32,69,-1:40,160,-1:27,71,-1:33,15,-1:65,16,-1:36,59,-1:38,1" +
"7,-1:36,61,-1:15,75,-1:48,76,-1:24,18,-1:41,77,-1:38,141,-1:30,19,-1:36,83," +
"-1:36,140,-1:44,143,-1:3,144,-1:42,84,-1:23,20,-1:37,21,-1:45,155,-1:46,85," +
"-1:35,86,-1:22,22,-1:41,23,-1:39,87,-1:35,24,-1:49,89,-1:25,90,-1:31,94,-1," +
"95,-1:35,25,-1:41,145,-1:33,26,-1:43,27,-1:44,98,-1:33,99,-1:45,146,-1:20,1" +
"00,-1:49,101,-1:28,102,-1:14,103,-1:18,104,-1:18,161,-1:25,105,-1:41,106,-1" +
":27,28,-1:50,108,-1:33,110,-1:29,111,-1:38,147,-1:14,156,-1:22,157,-1:35,11" +
"2,-1:45,148,-1:31,113,-1:37,29,-1:37,30,-1:41,31,-1:41,114,-1:33,115,-1:47," +
"118,-1:29,32,-1:35,33,-1:40,121,-1:28,34,-1:38,123,-1:36,124,-1:39,125,-1:3" +
"5,35,-1:50,126,-1:24,36,-1:53,150,-1:30,127,-1:36,37,-1:31,38,-1:48,129,-1:" +
"24,39,-1:39,40,-1:35,47,-1:38,65,-1:44,64,-1:29,135,-1:36,74,-1:52,78,-1:28" +
",72,-1:38,80,-1:39,81,-1:30,142,-1:52,91,-1:31,88,-1:44,96,-1:28,92,-1:35,9" +
"3,-1:35,107,-1:43,109,-1:35,149,-1:39,120,-1:43,122,-1:30,128,-1:36,70,-1:2" +
"9,67,-1:42,79,-1:38,82,-1:37,97,-1:35,116,-1:37,117,-1:37,119,-1:41,154,-1:" +
"41,139,-1:27,158,-1:33");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

return (new Symbol(sym_FIRST.EOF));
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						{return new Symbol(sym_FIRST.ERROR);}
					case -2:
						break;
					case 2:
						{return new Symbol(sym_FIRST.CE,yytext());}
					case -3:
						break;
					case 3:
						{return new Symbol(sym_FIRST.P_I,yytext());}
					case -4:
						break;
					case 4:
						{return new Symbol(sym_FIRST.P_D,yytext());}
					case -5:
						break;
					case 5:
						{return new Symbol(sym_FIRST.NOMBRE,yytext());}
					case -6:
						break;
					case 6:
						{return new Symbol(sym_FIRST.VARIABLE,yytext());}
					case -7:
						break;
					case 7:
						{return new Symbol(sym_FIRST.OR,yytext());}
					case -8:
						break;
					case 8:
						{return new Symbol(sym_FIRST.AND,yytext());}
					case -9:
						break;
					case 9:
						{return new Symbol(sym_FIRST.NOT,yytext());}
					case -10:
						break;
					case 10:
						{return new Symbol(sym_FIRST.NOT_C,yytext());}
					case -11:
						break;
					case 11:
						{return new Symbol(sym_FIRST.EQUAL,yytext());}
					case -12:
						break;
					case 12:
						{return new Symbol(sym_FIRST.SEPARATOR,yytext());}
					case -13:
						break;
					case 13:
						{}
					case -14:
						break;
					case 14:
						
					case -15:
						break;
					case 15:
						{return new Symbol(sym_FIRST.CU,yytext());}
					case -16:
						break;
					case 16:
						{return new Symbol(sym_FIRST.IMPLICA,yytext());}
					case -17:
						break;
					case 17:
						{return new Symbol(sym_FIRST.BIMPLICA,yytext());}
					case -18:
						break;
					case 18:
						{return new Symbol(sym_FIRST.AZUL,yytext());}
					case -19:
						break;
					case 19:
						{return new Symbol(sym_FIRST.ROJO,yytext());}
					case -20:
						break;
					case 20:
						{return new Symbol(sym_FIRST.CUBO,yytext());}
					case -21:
						break;
					case 21:
						{return new Symbol(sym_FIRST.TAUTO,yytext());}
					case -22:
						break;
					case 22:
						{return new Symbol(sym_FIRST.ABAJO,yytext());}
					case -23:
						break;
					case 23:
						{return new Symbol(sym_FIRST.FALSE,yytext());}
					case -24:
						break;
					case 24:
						{return new Symbol(sym_FIRST.ENTRE,yytext());}
					case -25:
						break;
					case 25:
						{return new Symbol(sym_FIRST.ARRIBA,yytext());}
					case -26:
						break;
					case 26:
						{return new Symbol(sym_FIRST.ESFERA,yytext());}
					case -27:
						break;
					case 27:
						{return new Symbol(sym_FIRST.GRANDE,yytext());}
					case -28:
						break;
					case 28:
						{return new Symbol(sym_FIRST.DERECHA,yytext());}
					case -29:
						break;
					case 29:
						{return new Symbol(sym_FIRST.AMARILLO,yytext());}
					case -30:
						break;
					case 30:
						{return new Symbol(sym_FIRST.PEQUENHO,yytext());}
					case -31:
						break;
					case 31:
						{return new Symbol(sym_FIRST.PIRAMIDE,yytext());}
					case -32:
						break;
					case 32:
						{return new Symbol(sym_FIRST.ALREDEDOR,yytext());}
					case -33:
						break;
					case 33:
						{return new Symbol(sym_FIRST.MASGRANDE,yytext());}
					case -34:
						break;
					case 34:
						{return new Symbol(sym_FIRST.MISMAFILA,yytext());}
					case -35:
						break;
					case 35:
						{return new Symbol(sym_FIRST.IZQUIERDA,yytext());}
					case -36:
						break;
					case 36:
						{return new Symbol(sym_FIRST.MISMAFORMA,yytext());}
					case -37:
						break;
					case 37:
						{return new Symbol(sym_FIRST.MISMOCOLOR,yytext());}
					case -38:
						break;
					case 38:
						{return new Symbol(sym_FIRST.MASPEQUENHO,yytext());}
					case -39:
						break;
					case 39:
						{return new Symbol(sym_FIRST.MISMACOLUMNA,yytext());}
					case -40:
						break;
					case 40:
						{return new Symbol(sym_FIRST.MISMOTAMANHO,yytext());}
					case -41:
						break;
					case 42:
						{return new Symbol(sym_FIRST.ERROR);}
					case -42:
						break;
					case 44:
						{return new Symbol(sym_FIRST.ERROR);}
					case -43:
						break;
					case 46:
						{return new Symbol(sym_FIRST.ERROR);}
					case -44:
						break;
					case 48:
						{return new Symbol(sym_FIRST.ERROR);}
					case -45:
						break;
					case 50:
						{return new Symbol(sym_FIRST.ERROR);}
					case -46:
						break;
					case 52:
						{return new Symbol(sym_FIRST.ERROR);}
					case -47:
						break;
					case 54:
						{return new Symbol(sym_FIRST.ERROR);}
					case -48:
						break;
					case 56:
						{return new Symbol(sym_FIRST.ERROR);}
					case -49:
						break;
					case 58:
						{return new Symbol(sym_FIRST.ERROR);}
					case -50:
						break;
					case 60:
						{return new Symbol(sym_FIRST.ERROR);}
					case -51:
						break;
					case 62:
						{return new Symbol(sym_FIRST.ERROR);}
					case -52:
						break;
					case 130:
						{return new Symbol(sym_FIRST.ERROR);}
					case -53:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
